
package net.mcreator.vanadium.item;

import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ArmorMaterial;
import net.minecraft.world.item.ArmorItem;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.Entity;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.sounds.SoundEvent;

import net.mcreator.vanadium.init.VanadiumModItems;

public abstract class VanadiumArmorItem extends ArmorItem {
	public VanadiumArmorItem(ArmorItem.Type type, Item.Properties properties) {
		super(new ArmorMaterial() {
			@Override
			public int getDurabilityForType(ArmorItem.Type type) {
				return new int[]{13, 15, 16, 11}[type.getSlot().getIndex()] * 85;
			}

			@Override
			public int getDefenseForType(ArmorItem.Type type) {
				return new int[]{11, 34, 28, 11}[type.getSlot().getIndex()];
			}

			@Override
			public int getEnchantmentValue() {
				return 51;
			}

			@Override
			public SoundEvent getEquipSound() {
				return SoundEvents.EMPTY;
			}

			@Override
			public Ingredient getRepairIngredient() {
				return Ingredient.of(new ItemStack(VanadiumModItems.VANADIUM.get()));
			}

			@Override
			public String getName() {
				return "vanadium_armor";
			}

			@Override
			public float getToughness() {
				return 0f;
			}

			@Override
			public float getKnockbackResistance() {
				return 0f;
			}
		}, type, properties);
	}

	public static class Helmet extends VanadiumArmorItem {
		public Helmet() {
			super(ArmorItem.Type.HELMET, new Item.Properties());
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "vanadium:textures/models/armor/vanadium_layer_1.png";
		}
	}

	public static class Chestplate extends VanadiumArmorItem {
		public Chestplate() {
			super(ArmorItem.Type.CHESTPLATE, new Item.Properties());
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "vanadium:textures/models/armor/vanadium_layer_1.png";
		}
	}

	public static class Leggings extends VanadiumArmorItem {
		public Leggings() {
			super(ArmorItem.Type.LEGGINGS, new Item.Properties());
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "vanadium:textures/models/armor/vanadium_layer_2.png";
		}
	}

	public static class Boots extends VanadiumArmorItem {
		public Boots() {
			super(ArmorItem.Type.BOOTS, new Item.Properties());
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "vanadium:textures/models/armor/vanadium_layer_1.png";
		}
	}
}
